﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NET4_CS
{
    class Tier { public string Name = ""; }
    class Katze : Tier { }

    // Eine Faktory-Funktion, die eine Instanz liefert
    delegate T Create<out T>();
    // Eine Funktion, die eine Aktion ausführt mit einem Objekt
    delegate void Action<in T>(T a);

    class DelegateVarianzDemo
    {

        public static Katze CreateKatze()
        {
            return new Katze();
        }

        public static void Print(Tier t)
        {
            Console.WriteLine(t.Name);
        }

        public static void run()
        {
            // Co-Varianz nutzen
            Create<Katze> CKatze = CreateKatze;
            Create<Tier> CTier = CKatze;

            // Kontra-Varianz nutzen
            Action<Tier> PTier = Print;
            Action<Katze> PKatze = PTier;
        }
    }
}
