﻿Imports System.Text

Namespace NET4_CS
 ''' <summary>
 ''' Kontra-Varianz bei Collections 
 ''' </summary>
 Friend Class CollectionVarianzDemo

  ''' <summary>
  ''' Diese Methode erwartet eine Menge von Objekten
  ''' </summary>
  Public Shared Sub Print(ByVal c As IEnumerable(Of Object))
	  Console.WriteLine("Anzahl: " & c.Count())
  End Sub

  Public Shared Sub Run()
   Dim Namen As New List(Of String)() From {"Müller", "Meier", "Schulze"}
   ' Die Methode erhält eine Menge von Strings
   ' Bisher war das nicht möglich, weil Enumerable<T>
   ' nicht Kontra-Varianz untersützte!
   Print(Namen)
  End Sub
 End Class
End Namespace
