﻿Imports System.Text

Namespace NET4_CS

 ''' <summary>
 ''' Optionale und benannte Parameter - neu in C# 4.0
 ''' </summary>
 Friend Class ParameterDemo


  Public Shared Sub MsgBox(ByVal text As String, Optional ByVal caption As String = "Hinweis")
   MessageBox.Show(caption:= caption, text:= text)
  End Sub


  Public Shared Sub Run()
   ' bisher war nur möglich:
   'MessageBox.Show("Demo für benannte Parameter!", "Hinweis");
   ' Jetzt ist auch möglich:
   'MessageBox.Show(caption: "Hinweis", text: "Demo für benannte Parameter!");


   ' Aufruf in externer DLL
   Dim p As NET4_GL.Person = NET4_GL.Person.Create("Meier")
   Dim p2 As NET4_GL.Person = NET4_GL.Person.Create("")

  End Sub



 End Class
End Namespace
