﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NET4_CS
{
 /// <summary>
 /// Kontra-Varianz bei Collections 
 /// </summary>
 class CollectionVarianzDemo
 {

  /// <summary>
  /// Diese Methode erwartet eine Menge von Objekten
  /// </summary>
  public static void Print(IEnumerable<object> c)
  { Console.WriteLine("Anzahl: " + c.Count()); }

  public static void Run()
  {
   List<string> Namen = new List<string> { "Müller", "Meier", "Schulze" };
   // Die Methode erhält eine Menge von Strings
   // Bisher war das nicht möglich, weil Enumerable<T>
   // nicht Kontra-Varianz untersützte!
   Print(Namen);
  }
 }
}
