﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NET4_CS
{

 /// <summary>
 /// Einige Delegates in C#, die in VB umgesetzt werden solen
 /// </summary>
 class DelegateDemo
 {

  public static void Run()
  {
   var Zahlen = new List<int> { 1, 2, 6, 8, 4, 6, 8, 1, 2, 5, 8, 4, 3, 6, 2 };
   var KleineZahlen = Zahlen.Where(x => x < 10);

   Console.WriteLine("ObservableCollection: Create...");
   var oc = new System.Collections.ObjectModel.ObservableCollection<int>(KleineZahlen);
   oc.CollectionChanged += (o, e) =>
   {
    Console.WriteLine(e.Action.ToString());
   };
   oc.CollectionChanged += (o, e) =>
  {
   if (e.NewItems != null) Console.WriteLine("Neue: " + e.NewItems.Count);
   if (e.OldItems != null) Console.WriteLine("Alte: " + e.OldItems.Count);
  };

   Console.WriteLine("ObservableCollection: Add...");


   var CEBIT = new Messe();
      CEBIT.Test();



   oc.Add(100);
   oc.Add(1);
   oc.Remove(100);
   Console.ReadLine();

  }


 }






}
