﻿Imports System.Text

Namespace NET4_CS

 ''' <summary>
 ''' Einige Delegates in C#, die in VB umgesetzt werden solen
 ''' </summary>
 Friend Class DelegateDemo

  Public Shared Sub Run()

   ' Collection Initializer - eindimentional
   Dim Zahlen = New List(Of Integer) From {1, 2, 6, 8, 4, 6, 8, 1, 2, 5, 8, 4, 3, 6, 2}

   ' Collection Initializer - mehrdimensional
   Dim Zahlen2 = New Integer(3, 1) {{1, 2}, {6, 9}, {4, 3}, {7, 2}}

   'Dim Zahlen3 = New List(Of List(Of Integer)) From {{1, 2}, {7, 8, 9}, {3}, {2}}





   Dim KleineZahlen = Zahlen.Where(Function(x) x < 10)

   Console.WriteLine("ObservableCollection: Create...")
   Dim oc = New System.Collections.ObjectModel.ObservableCollection(Of Integer)(KleineZahlen)
   ' Inline Delegate einzeilig
   AddHandler oc.CollectionChanged, Sub(o, e) Console.WriteLine(e.Action.ToString())

   ' Inline Delegate mehrzeilig
   AddHandler oc.CollectionChanged, Sub(o, e)
                                     If e.NewItems IsNot Nothing Then
                                      Console.WriteLine("Neue: " & e.NewItems.Count)
                                     End If
                                     If e.OldItems IsNot Nothing Then
                                      Console.WriteLine("Alte: " & e.OldItems.Count)
                                     End If
                                    End Sub

   Console.WriteLine("ObservableCollection: Add...")

   oc.Add(100)
   oc.Add(1)
   oc.Remove(100)
   Console.ReadLine()

  End Sub


 End Class






End Namespace
