﻿Imports System.Text

Namespace NET4_CS
	Friend Class Tier
		Public Name As String = ""
	End Class
	Friend Class Katze
		Inherits Tier
	End Class

	' Eine Faktory-Funktion, die eine Instanz liefert
	Friend Delegate Function Create(Of Out T)() As T
	' Eine Funktion, die eine Aktion ausführt mit einem Objekt
	Friend Delegate Sub Action(Of In T)(ByVal a As T)

	Friend Class DelegateVarianzDemo

		Public Shared Function CreateKatze() As Katze
			Return New Katze()
		End Function

		Public Shared Sub Print(ByVal t As Tier)
			Console.WriteLine(t.Name)
		End Sub

		Public Shared Sub run()
			' Co-Varianz nutzen
			Dim CKatze As Create(Of Katze) = AddressOf CreateKatze
			Dim CTier As Create(Of Tier) = CKatze

			' Kontra-Varianz nutzen
			Dim PTier As Action(Of Tier) = AddressOf Print
			Dim PKatze As Action(Of Katze) = PTier
		End Sub
	End Class
End Namespace
