﻿Imports System.Text
Imports System.Collections

Namespace NET4_CS

 Public Class Kunde
  Public Name As String
  Public Ort As String
  Public Umsatz As Double
 End Class

 Public Class Lieferant
  Public Name As String
  Public Ort As String
  Public Produkte As List(Of String)
 End Class

 ''' <summary>
 ''' Beispiel für das neue Schlüsselwort "dynamic"
 ''' </summary>
 Friend Class DynamicDemo

  Public Shared Sub run()


   Dim k1 As New Kunde() With {.Name = "Meier", .Ort = "Zürich", .Umsatz = 10000.00f}
   Dim k2 As New Kunde() With {.Name = "Müller", .Ort = "Berlin", .Umsatz = 20000.00f}
   Dim l1 As New Lieferant() With {.Name = "Schulze", .Ort = "Hamburg", .Produkte = New List(Of String) From {"Software", "Hardware"}}

   Dim Adressen As New ArrayList() From { k1, k2, l1 }


   For Each d As Object In Adressen
    Console.WriteLine(d.Name & " aus " & d.Ort)
    If TypeOf d Is Kunde Then
     Console.WriteLine("  Kunde mit Umsatz: " & d.Umsatz.ToString())
    End If
    If TypeOf d Is Lieferant Then
     Console.WriteLine("  Lieferant mit Produkten: " & String.Join(" ", d.Produkte.ToArray()))
    End If
   Next d

  End Sub

 End Class
End Namespace
